## Spring Thymeleaf 

This module contains articles about Spring with Thymeleaf

### Relevant Articles: 
- [Introduction to Using Thymeleaf in Spring](https://www.baeldung.com/thymeleaf-in-spring-mvc)
- [CSRF Protection with Spring MVC and Thymeleaf](https://www.baeldung.com/csrf-thymeleaf-with-spring-security)
- [Thymeleaf: Custom Layout Dialect](https://www.baeldung.com/thymeleaf-spring-layouts)
- [Spring and Thymeleaf 3: Expressions](https://www.baeldung.com/spring-thymeleaf-3-expressions)
- [Spring MVC + Thymeleaf 3.0: New Features](https://www.baeldung.com/spring-thymeleaf-3)
- [How to Work with Dates in Thymeleaf](https://www.baeldung.com/dates-in-thymeleaf)
- [Working with Fragments in Thymeleaf](https://www.baeldung.com/spring-thymeleaf-fragments)
- [Conditionals in Thymeleaf](https://www.baeldung.com/spring-thymeleaf-conditionals)
- [Iteration in Thymeleaf](https://www.baeldung.com/thymeleaf-iteration)
- [Spring with Thymeleaf Pagination for a List](https://www.baeldung.com/spring-thymeleaf-pagination)
- [[next -->]](/spring-thymeleaf-2)

### Build the Project

mvn clean install

### Run the Project

mvn cargo:run
- **note**: starts on port '8082'

Access the pages using the URLs:

 - http://localhost:8082/spring-thymeleaf/
 - http://localhost:8082/spring-thymeleaf/addStudent/
 - http://localhost:8082/spring-thymeleaf/listStudents/

The first URL is the home page of the application. The home page has links to the second and third pages.

### Security
The user/password required is: user1/user1Pass
